stapel  segment stack
	db 100h dup (?)
stapel  ends

daten   segment

lastoffs        dw 0
start_match     dw 0
end_match       dw 0
substi_len      dw 0

search  db "ich", 0
substi  db "wir", 0

text    db "Assembler? Beherrsche ich perfekt. "
        db "Nichts leichter als das.", 13, 10
	db "Da macht mir keiner was vor.", 13, 10, '$', 0

textend	label byte
dummy   db 1024 dup (?)

daten   ends


code    segment 'code'
	assume cs:code, ds:daten

extrn	strlen : proc
extrn	copy : 	proc

start:

	mov  ax, daten          ; Laden der Anfangsadresse des
	mov  ds, ax             ; Datensegment nach ds
	mov  es, ax		; Datensegment nach es

	mov  di, offset substi	; Stringlnge des Substit.-Strings ermitteln
	call strlen
	mov  [substi_len], cx	; Lnge in substi_len speichern

	mov  ax, offset textend ; letzten gltigen Offset feststellen,
	sub  ax, cx             ; an dem eine Textuntersuchung noch 
	mov  [lastoffs], ax	; zulssig ist

	mov  dx, cx             ; cx = Lnge Such-String
	mov  bx, offset text    ; Anfangsadresse Text
back:   
	cmp  bx, [lastoffs]     ; Ende erreicht?
	jg   raus               ; wenn ja, springe zu raus
	mov  cx, dx             ; cx = Lnge Such-String laden
	mov  di, bx             ; di = aktueller Textanfang
	mov  si, offset search  ; si = Adresse Such-String
	repe cmpsb              ; wiederhole Vergleich solange bereinstimmung
        je   ersetze            ; nur bei vollstndig exakten Vergleich ist
				; Zero-Flag 1
        inc  bx                 ; weiter bei naechstem Zeichen
        jmp  back
ersetze:
	mov  [start_match], bx	; Anfang des Suchstrings in text
	mov  [end_match], di	; Offset des nachfolgenden Texts in text
	mov  di, bx  		; di auf Anfang des Suchstrings im Text setzen
	mov  si, offset substi	; si = Adresse Substit.- String
	mov  cx, [substi_len]	; cx = Lnge Substit.-String
	call copy
        add  bx, [substi_len]   ; bei Zeichen hinter Sustit. fortfahren 
	jmp  back
	
raus:   mov  dx, offset text	; String-Ausgabe ber DOS-Interrupt
	mov  ah, 09h
	int  21h	
	mov  ax,4c00h           ; Zurck zu DOS
	int  21h

code	ends
end start   
